<?php

namespace Drupal\mdp\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\Attribute\FieldFormatter;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\StringTranslation\TranslatableMarkup;
use Drupal\datetime\Plugin\Field\FieldFormatter\DateTimeCustomFormatter;

/**
 * Plugin implementation of the 'mdp' formatter.
 */
#[FieldFormatter(
  id: 'field_mdp_formatter',
  label: new TranslatableMarkup('MDP - Formatter'),
  field_types: [
    'field_mdp',
  ]
)]
class MDPCustomFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];

    foreach ($items as $delta => $item) {
      $elements[$delta] = [
        '#markup' => $item->value['value']['value']['mdp']['value'],
      ];
    }

    return $elements;
  }
}
