<?php

namespace Drupal\mdp\Plugin\Field\FieldWidget;

use Drupal\Core\Field\Attribute\FieldWidget;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\StringTranslation\TranslatableMarkup;

#[FieldWidget(
  id: 'field_mdp_widget',
  label: new TranslatableMarkup('MDP - Widget'),
  field_types: ['field_mdp']
)]
class MDPDefaultWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {

    $value = $items[$delta]->value['value'] ?? '';
    $dataSettings = [
      'separator' => $this->fieldDefinition->getSetting('separator')
    ];

    $detail['mdp'] = [
      '#type' => 'details',
      '#title' => t('Multi Dates Picker'),
      '#open' => strlen($value['value']['mdp']['value']) > 0,
      '#group' => 'advanced',
      '#tree' => TRUE,
      '#weight' => -3,
    ];

    $detail['mdp']['value'] = [
      '#type' => 'textfield',
      '#default_value' => $value['value']['mdp'],
      '#attributes' => [
        'class' => ["edit-field-mdp-widget"],
        'autocomplete' => "off",
        'data-settings' => json_encode($dataSettings),
      ],
      '#maxlength' => 255,
      '#attached' => [
        'library' => [
          'mdp/mdp'
        ],
      ]
    ];

    $element += $detail;

    return ['value' => $element];
  }
}
